import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An explosion that i use a lot.
 * 
 * @author Ninto
 * @version 0.1
 */
public class explosion  extends superClass
{
    /**The current frame*/
    private float cur_frame = 0;
    /**The last frame*/
    private int end_frame;
    /**Whether this is a big explosion or a small*/
    private boolean big;
    
    /**The images*/
    private static GreenfootImage[] exploframes = new GreenfootImage[12];
    /**The images*/
    private static GreenfootImage[] hugeexploframes = new GreenfootImage[15];
    
    /**
     * Load the explosion images.
     * @param big Whether this explosion is big or small.
     */
    public explosion(boolean big) {
        this.big = big;
        if(exploframes[0] == null) {
            exploframes[0] = new GreenfootImage("explosionframea.png");
            exploframes[1] = new GreenfootImage("explosionframeb.png");
            exploframes[2] = new GreenfootImage("explosionframec.png");
            exploframes[3] = new GreenfootImage("explosionframed.png");
            exploframes[4] = new GreenfootImage("explosionframee.png");
            exploframes[5] = new GreenfootImage("explosionframef.png");
            exploframes[6] = new GreenfootImage("explosionframeg.png");
            exploframes[7] = new GreenfootImage("explosionframeh.png");
            exploframes[8] = new GreenfootImage("explosionframei.png");
            exploframes[9] = new GreenfootImage("explosionframej.png");
            exploframes[10] = new GreenfootImage("explosionframek.png");
            exploframes[11] = new GreenfootImage("explosionframel.png");
            
            hugeexploframes[0] = new GreenfootImage("hugeexploframea.png");
            hugeexploframes[1] = new GreenfootImage("hugeexploframeb.png");
            hugeexploframes[2] = new GreenfootImage("hugeexploframec.png");
            hugeexploframes[3] = new GreenfootImage("hugeexploframed.png");
            hugeexploframes[4] = new GreenfootImage("hugeexploframee.png");
            hugeexploframes[5] = new GreenfootImage("hugeexploframef.png");
            hugeexploframes[6] = new GreenfootImage("hugeexploframeg.png");
            hugeexploframes[7] = new GreenfootImage("hugeexploframeh.png");
            hugeexploframes[8] = new GreenfootImage("hugeexploframei.png");
            hugeexploframes[9] = new GreenfootImage("hugeexploframej.png");
            hugeexploframes[10] = new GreenfootImage("hugeexploframek.png");
            hugeexploframes[11] = new GreenfootImage("hugeexploframel.png");
            hugeexploframes[12] = new GreenfootImage("hugeexploframem.png");
            hugeexploframes[13] = new GreenfootImage("hugeexploframen.png");
            hugeexploframes[14] = new GreenfootImage("hugeexploframeo.png");
        }
        if(!big) {end_frame = 12; setImage(exploframes[0]);}
        if(big) {end_frame = 15; setImage(hugeexploframes[0]);}
        Greenfoot.playSound("explosion.wav");
    }
    
    /**
     * Choose which images to animate.
     */
    public void act() {
        if(big) animate(hugeexploframes);
        if(!big) animate(exploframes);
    }
    
    /**
     * Animate the frames of the explosion.
     * @param frames The images to be animated.
     */
    private void animate(GreenfootImage[] frames) {
        if(cur_frame >= end_frame) {getWorld().removeObject(this); return;}
        setImage(frames[(int)cur_frame]);
        cur_frame+=.5f;
    }
}