import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A label.
 * 
 * @author Ninto
 * @version 0.1
 */
public class label  extends Actor
{
    /**The prefix of the label*/
    private final String prefix;
    /**The current value*/
    private int value;
    /**The target to reach*/
    private int target;
    
    /**
     * Act - do whatever the label wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if(target != value) {
            if(target < value) value--;
            if(target > value) value++;
            updateImage();
        }
    }
    
    /**
     * Create a label.
     * @param prefix The prefix of the label.<br>
     * @param value The start value.
     */
    public label(String prefix, int value)
    {
        this.prefix = prefix;
        target = value;
        this.value = value;
        setImage(new GreenfootImage((prefix.length() + 3)*12, 24));
        updateImage();
    }
    
    /**
     * Get the current value of this label.
     * @return The value.
     */
    public int getValue()
    {
        return target;
    }
    
    /**
     * Set the value.
     * @param value The value.
     */
    public void setValue(int value)
    {
        if(value > 999) value = 999;
        if(value < 0) value = 0;
        target = value;
        updateImage();
    }
    
    /**
     * Get the prefix of this.
     * @return The prefix of this label.
     */
    public String getPrefix()
    {
        return prefix;
    }
    
    /**
     * Update the image.
     */
    private void updateImage()
    {
        GreenfootImage img = getImage();
        img.clear();
        img.drawString(prefix+": "+value, 1, 12);
    }
}