import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world.
 * 
 * @author Ninto
 * @version 0.1
 */
public class myWorld  extends World
{
    /**The force of the gravity*/
    final static double gravity = .5;
    /**How much the balls shall slow down when there is on ground*/
    final static double groundFriction = .2;
    /**Name of the music files*/
    private final String[] music = {
        "SSBB", "Mario", "Zelda", "Kirby", "Pokmon", "Metroid", "Mother", "KidIcarus", "FireEmblem", "IceClimbers"
    };
    /**The audioPlayer to play the music*/
    private audioPlayer audio = new audioPlayer("Mario");
    
    /**
     * Create a world.
     */
    public myWorld() {
        super(640, 480, 1);
        setPaintOrder(turret.class, turretB.class, ball.class);
        Greenfoot.setSpeed(50);
        addObject(new turret(), 100, getHeight()-100);
        addObject(new turretB(), 100, getHeight()-100);
    }
    
    /**
     * Act - do whatever the myWorld wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        if(Greenfoot.isKeyDown("space")) addObject(new wheely(), getRandomX(), getRandomY());
        for(int f=0; f<10; f++) if(Greenfoot.isKeyDown(""+f))
        setMusic(music[f]);
        audio.act();
    }
    
    /**
     * This method is called by the Greenfoot system when the execution has stopped.
     */
    public void stopped() {
        audio.sequencer.stop();
    }
    
    /**
     * This method is called by the Greenfoot system when the execution has started.
     */
    public void started() {
        audio.sequencer.start();
    }
    
    /**
     * Set the music to be played.
     */
    public void setMusic(String fileName) {
        audio.setSong(fileName);
    }
    
    /**
     * Generate a random number between 0 and the limit of the world width minus 1.
     */
    public int getRandomX() {
        return Greenfoot.getRandomNumber(getWidth());
    }
    
    /**
     * Generate a random number between 0 and the limit of the world height minus 1.
     */
    public int getRandomY() {
        return Greenfoot.getRandomNumber(getHeight());
    }
}