import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The barrel of a turret.
 * 
 * @author Ninto
 * @version 0.1
 * @see turret
 */
public class turretB  extends turret
{
    /**The delay between the individuel bullets*/
    private static final int MAX_DELAY = 15;
    /**The current delay*/
    private int delay = MAX_DELAY;
    /**Am i shooting or not?*/
    private boolean shooting;
    
    /**
     * Act - do whatever the turretB wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if(Greenfoot.getMouseInfo() != null)
        setRotation((int)Math.toDegrees(Math.atan2(Greenfoot.getMouseInfo().getY()-getY(), Greenfoot.getMouseInfo().getX()-getX())));
        if(getRotation() > 0) setRotation(0);
        
        if(Greenfoot.mousePressed(null)) shooting = true;
        if(Greenfoot.mouseClicked(null)) shooting = false;
        if(shooting && delay <= 0) shootBall(new ball(getRotation(), 16));
        else if(delay > 0) delay--;
    }
    
    /**
     * Create a bullet.
     * @param myBall The bullet to be created.
     */
    private void shootBall(ball myBall) {
        double angle = Math.toRadians(getRotation());
        int x = (int)Math.round(getX() + Math.cos(angle)*(getImage().getWidth()/2+5));
        int y = (int)Math.round(getY() + Math.sin(angle)*(getImage().getWidth()/2+5));
        
        getWorld().addObject(myBall, x, y);
        delay = MAX_DELAY;
    }
}